Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/FeatureCorrelation/AbstractFeatureCorrelationView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/FeatureCorrelation/AbstractFeatureCorrelationView.Designer.cs	(revision 8880)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/FeatureCorrelation/AbstractFeatureCorrelationView.Designer.cs	(revision 8881)
@@ -49,5 +49,5 @@
       this.components = new System.ComponentModel.Container();
       System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(AbstractFeatureCorrelationView));
-      this.heatMapProgressBar = new System.Windows.Forms.ProgressBar();
+      this.progressBar = new System.Windows.Forms.ProgressBar();
       this.partitionComboBox = new System.Windows.Forms.ComboBox();
       this.correlationCalcLabel = new System.Windows.Forms.Label();
@@ -58,6 +58,6 @@
       this.pictureBox = new System.Windows.Forms.PictureBox();
       this.splitContainer = new System.Windows.Forms.SplitContainer();
-      this.calculatingPanel = new System.Windows.Forms.Panel();
-      this.calculatingLabel = new System.Windows.Forms.Label();
+      this.progressPanel = new System.Windows.Forms.Panel();
+      this.progressLabel = new System.Windows.Forms.Label();
       this.dataView = new HeuristicLab.Problems.DataAnalysis.Views.EnhancedStringConvertibleMatrixView();
       ((System.ComponentModel.ISupportInitialize)(this.pictureBox)).BeginInit();
@@ -66,15 +66,15 @@
       this.splitContainer.Panel2.SuspendLayout();
       this.splitContainer.SuspendLayout();
-      this.calculatingPanel.SuspendLayout();
+      this.progressPanel.SuspendLayout();
       this.SuspendLayout();
       // 
       // HeatMapProgressBar
       // 
-      this.heatMapProgressBar.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Left | System.Windows.Forms.AnchorStyles.Right)));
-      this.heatMapProgressBar.Location = new System.Drawing.Point(25, 46);
-      this.heatMapProgressBar.Name = "HeatMapProgressBar";
-      this.heatMapProgressBar.RightToLeft = System.Windows.Forms.RightToLeft.No;
-      this.heatMapProgressBar.Size = new System.Drawing.Size(154, 21);
-      this.heatMapProgressBar.TabIndex = 9;
+      this.progressBar.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Left | System.Windows.Forms.AnchorStyles.Right)));
+      this.progressBar.Location = new System.Drawing.Point(25, 46);
+      this.progressBar.Name = "HeatMapProgressBar";
+      this.progressBar.RightToLeft = System.Windows.Forms.RightToLeft.No;
+      this.progressBar.Size = new System.Drawing.Size(154, 21);
+      this.progressBar.TabIndex = 9;
       // 
       // PartitionComboBox
@@ -171,5 +171,5 @@
       // SplitContainer.Panel2
       // 
-      this.splitContainer.Panel2.Controls.Add(this.calculatingPanel);
+      this.splitContainer.Panel2.Controls.Add(this.progressPanel);
       this.splitContainer.Panel2.Controls.Add(this.dataView);
       this.splitContainer.Size = new System.Drawing.Size(475, 330);
@@ -179,20 +179,20 @@
       // CalculatingPanel
       // 
-      this.calculatingPanel.Anchor = System.Windows.Forms.AnchorStyles.None;
-      this.calculatingPanel.Controls.Add(this.calculatingLabel);
-      this.calculatingPanel.Controls.Add(this.heatMapProgressBar);
-      this.calculatingPanel.Location = new System.Drawing.Point(138, 95);
-      this.calculatingPanel.Name = "CalculatingPanel";
-      this.calculatingPanel.Size = new System.Drawing.Size(200, 81);
-      this.calculatingPanel.TabIndex = 10;
+      this.progressPanel.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.progressPanel.Controls.Add(this.progressLabel);
+      this.progressPanel.Controls.Add(this.progressBar);
+      this.progressPanel.Location = new System.Drawing.Point(138, 95);
+      this.progressPanel.Name = "CalculatingPanel";
+      this.progressPanel.Size = new System.Drawing.Size(200, 81);
+      this.progressPanel.TabIndex = 10;
       // 
       // CalculatingLabel
       // 
-      this.calculatingLabel.AutoSize = true;
-      this.calculatingLabel.Location = new System.Drawing.Point(42, 19);
-      this.calculatingLabel.Name = "CalculatingLabel";
-      this.calculatingLabel.Size = new System.Drawing.Size(120, 13);
-      this.calculatingLabel.TabIndex = 10;
-      this.calculatingLabel.Text = "Calculating correlation...";
+      this.progressLabel.AutoSize = true;
+      this.progressLabel.Location = new System.Drawing.Point(42, 19);
+      this.progressLabel.Name = "CalculatingLabel";
+      this.progressLabel.Size = new System.Drawing.Size(120, 13);
+      this.progressLabel.TabIndex = 10;
+      this.progressLabel.Text = "Calculating correlation...";
       // 
       // DataGridView
@@ -221,6 +221,6 @@
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).EndInit();
       this.splitContainer.ResumeLayout(false);
-      this.calculatingPanel.ResumeLayout(false);
-      this.calculatingPanel.PerformLayout();
+      this.progressPanel.ResumeLayout(false);
+      this.progressPanel.PerformLayout();
       this.ResumeLayout(false);
 
@@ -229,5 +229,5 @@
     #endregion
 
-    protected System.Windows.Forms.ProgressBar heatMapProgressBar;
+    protected System.Windows.Forms.ProgressBar progressBar;
     protected System.Windows.Forms.ComboBox partitionComboBox;
     protected System.Windows.Forms.Label correlationCalcLabel;
@@ -238,6 +238,6 @@
     protected System.Windows.Forms.PictureBox pictureBox;
     protected System.Windows.Forms.SplitContainer splitContainer;
-    protected System.Windows.Forms.Panel calculatingPanel;
-    protected System.Windows.Forms.Label calculatingLabel;
+    protected System.Windows.Forms.Panel progressPanel;
+    protected System.Windows.Forms.Label progressLabel;
     protected HeuristicLab.Problems.DataAnalysis.Views.EnhancedStringConvertibleMatrixView dataView;
 
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/FeatureCorrelation/AbstractFeatureCorrelationView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/FeatureCorrelation/AbstractFeatureCorrelationView.cs	(revision 8880)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/FeatureCorrelation/AbstractFeatureCorrelationView.cs	(revision 8881)
@@ -118,10 +118,10 @@
 
     protected void Content_ProgressCalculation(object sender, ProgressChangedEventArgs e) {
-      if (!calculatingPanel.Visible && e.ProgressPercentage != heatMapProgressBar.Maximum) {
-        calculatingPanel.Show();
-      } else if (e.ProgressPercentage == heatMapProgressBar.Maximum) {
-        calculatingPanel.Hide();
+      if (!progressPanel.Visible && e.ProgressPercentage != progressBar.Maximum) {
+        progressPanel.Show();
+      } else if (e.ProgressPercentage == progressBar.Maximum) {
+        progressPanel.Hide();
       }
-      heatMapProgressBar.Value = e.ProgressPercentage;
+      progressBar.Value = e.ProgressPercentage;
     }
   }
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/FeatureCorrelation/TimeframeFeatureCorrelationView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/FeatureCorrelation/TimeframeFeatureCorrelationView.Designer.cs	(revision 8880)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/FeatureCorrelation/TimeframeFeatureCorrelationView.Designer.cs	(revision 8881)
@@ -59,5 +59,5 @@
       this.splitContainer.Panel2.SuspendLayout();
       this.splitContainer.SuspendLayout();
-      this.calculatingPanel.SuspendLayout();
+      this.progressPanel.SuspendLayout();
       this.SuspendLayout();
       // 
@@ -94,5 +94,5 @@
       // CalculatingPanel
       // 
-      this.calculatingPanel.Location = new System.Drawing.Point(138, 82);
+      this.progressPanel.Location = new System.Drawing.Point(138, 82);
       // 
       // VariableSelectionLabel
@@ -147,6 +147,6 @@
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).EndInit();
       this.splitContainer.ResumeLayout(false);
-      this.calculatingPanel.ResumeLayout(false);
-      this.calculatingPanel.PerformLayout();
+      this.progressPanel.ResumeLayout(false);
+      this.progressPanel.PerformLayout();
       this.ResumeLayout(false);
 