Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/DirectScheduleGTCrossoverTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/DirectScheduleGTCrossoverTest.cs	(revision 8887)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/DirectScheduleGTCrossoverTest.cs	(revision 8888)
@@ -1,8 +1,31 @@
-﻿using HeuristicLab.Core;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.ScheduleEncoding;
 using HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition;
 using HeuristicLab.Encodings.ScheduleEncoding.ScheduleEncoding;
+using HeuristicLab.Tests;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.Tests_33.Tests {
+namespace HeuristicLab.Encodings.ScheduleEncoding_33.Tests {
 
 
@@ -66,5 +89,5 @@
     [TestMethod()]
     public void ApplyTest() {
-      IRandom random = new TestRandom(new int[] { 1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1 }, null);
+      IRandom random = new TestRandom(new int[] {  1, 1, 1, 1, 1, 0, 1, 0, 1, 1, 1, 0, 1, 0, 1, 1, 1, 1 }, new double[] { 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9, 0.9 });
       Schedule parent1 = TestUtils.CreateTestSchedule1();
       Schedule parent2 = TestUtils.CreateTestSchedule2();
Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/JSMJOXCrossoverTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/JSMJOXCrossoverTest.cs	(revision 8887)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/JSMJOXCrossoverTest.cs	(revision 8888)
@@ -2,7 +2,8 @@
 using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Encodings.ScheduleEncoding.JobSequenceMatrix;
+using HeuristicLab.Tests;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.Tests_33.Tests {
+namespace HeuristicLab.Encodings.ScheduleEncoding_33.Tests {
 
 
Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/JSMSXXCrossoverTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/JSMSXXCrossoverTest.cs	(revision 8887)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/JSMSXXCrossoverTest.cs	(revision 8888)
@@ -2,7 +2,8 @@
 using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Encodings.ScheduleEncoding.JobSequenceMatrix;
+using HeuristicLab.Tests;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.Tests_33.Tests {
+namespace HeuristicLab.Encodings.ScheduleEncoding_33.Tests {
 
 
Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/JSMShiftChangeManipulatorTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/JSMShiftChangeManipulatorTest.cs	(revision 8887)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/JSMShiftChangeManipulatorTest.cs	(revision 8888)
@@ -2,7 +2,8 @@
 using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Encodings.ScheduleEncoding.JobSequenceMatrix;
+using HeuristicLab.Tests;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.Tests_33.Tests {
+namespace HeuristicLab.Encodings.ScheduleEncoding_33.Tests {
 
 
Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/PWRGOXCrossoverTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/PWRGOXCrossoverTest.cs	(revision 8887)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/PWRGOXCrossoverTest.cs	(revision 8888)
@@ -2,7 +2,8 @@
 using HeuristicLab.Encodings.IntegerVectorEncoding;
 using HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition;
+using HeuristicLab.Tests;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.Tests_33.Tests {
+namespace HeuristicLab.Encodings.ScheduleEncoding_33.Tests {
 
 
Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/PWRPPXCrossoverTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/PWRPPXCrossoverTest.cs	(revision 8887)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/PWRPPXCrossoverTest.cs	(revision 8888)
@@ -2,7 +2,8 @@
 using HeuristicLab.Encodings.IntegerVectorEncoding;
 using HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition;
+using HeuristicLab.Tests;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.Tests_33.Tests {
+namespace HeuristicLab.Encodings.ScheduleEncoding_33.Tests {
 
 
Index: unk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/TestRandom.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/TestRandom.cs	(revision 8887)
+++ 	(revision )
@@ -1,141 +1,0 @@
-﻿#region License Information
-/* HeuristicLab
- * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
- *
- * This file is part of HeuristicLab.
- *
- * HeuristicLab is free software: you can redistribute it and/or modify
- * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation, either version 3 of the License, or
- * (at your option) any later version.
- *
- * HeuristicLab is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
- */
-#endregion
-
-using System;
-using HeuristicLab.Common;
-using HeuristicLab.Core;
-
-namespace HeuristicLab.Encodings.ScheduleEncoding.Tests_33.Tests {
-  public class TestRandom : IRandom {
-    #region Variables and Properties
-    private int[] intNumbers;
-    public int[] IntNumbers {
-      get { return intNumbers; }
-      set {
-        if (value == null) intNumbers = new int[0];
-        else intNumbers = value;
-      }
-    }
-    private int nextIntIndex;
-    private double[] doubleNumbers;
-    public double[] DoubleNumbers {
-      get { return doubleNumbers; }
-      set {
-        if (value == null) doubleNumbers = new double[0];
-        else doubleNumbers = value;
-      }
-    }
-    private int nextDoubleIndex;
-    #endregion
-
-    public TestRandom() {
-      intNumbers = new int[0];
-      doubleNumbers = new double[0];
-      nextIntIndex = 0;
-      nextDoubleIndex = 0;
-    }
-
-    public TestRandom(int[] intNumbers, double[] doubleNumbers) {
-      if (intNumbers == null) intNumbers = new int[0];
-      else this.intNumbers = intNumbers;
-      if (doubleNumbers == null) doubleNumbers = new double[0];
-      else this.doubleNumbers = doubleNumbers;
-      nextIntIndex = 0;
-      nextDoubleIndex = 0;
-    }
-
-    #region IRandom Members
-
-    public void Reset() {
-      nextIntIndex = 0;
-      nextDoubleIndex = 0;
-    }
-
-    public void Reset(int seed) {
-      throw new NotImplementedException();
-    }
-
-    public int Next() {
-      if (nextIntIndex >= intNumbers.Length) throw new InvalidOperationException("Random: No more integer random numbers available");
-      return intNumbers[nextIntIndex++];
-    }
-
-    public int Next(int maxVal) {
-      if (nextIntIndex >= intNumbers.Length) throw new InvalidOperationException("Random: No more integer random numbers available");
-      if (IntNumbers[nextIntIndex] >= maxVal) throw new InvalidOperationException("Random: Next integer random number (" + IntNumbers[nextIntIndex] + ") is >= " + maxVal);
-      return intNumbers[nextIntIndex++];
-    }
-
-    public int Next(int minVal, int maxVal) {
-      if (nextIntIndex >= intNumbers.Length) throw new InvalidOperationException("Random: No more integer random numbers available");
-      if (IntNumbers[nextIntIndex] < minVal || IntNumbers[nextIntIndex] >= maxVal) throw new InvalidOperationException("Random: Next integer random number (" + IntNumbers[nextIntIndex] + ") is not in the range [" + minVal + ";" + maxVal + ")");
-      return intNumbers[nextIntIndex++];
-    }
-
-    public double NextDouble() {
-      if (nextDoubleIndex >= doubleNumbers.Length) throw new InvalidOperationException("Random: No more double random numbers available");
-      if (doubleNumbers[nextDoubleIndex] < 0.0 || doubleNumbers[nextDoubleIndex] >= 1.0) throw new InvalidOperationException("Random: Next double ranomd number (" + DoubleNumbers[nextDoubleIndex] + ") is not in the range [0;1)");
-      return doubleNumbers[nextDoubleIndex++];
-    }
-
-    #endregion
-
-    #region IItem Members
-
-    public string ItemName {
-      get { throw new NotImplementedException(); }
-    }
-
-    public string ItemDescription {
-      get { throw new NotImplementedException(); }
-    }
-
-    public Version ItemVersion {
-      get { throw new NotImplementedException(); }
-    }
-
-    public System.Drawing.Image ItemImage {
-      get { throw new NotImplementedException(); }
-    }
-
-#pragma warning disable 67
-    public event EventHandler ItemImageChanged;
-    public event EventHandler ToStringChanged;
-#pragma warning restore 67
-    #endregion
-
-    #region IDeepCloneable Members
-
-    public IDeepCloneable Clone(Cloner cloner) {
-      throw new NotImplementedException();
-    }
-
-    #endregion
-
-    #region ICloneable Members
-
-    public object Clone() {
-      throw new NotImplementedException();
-    }
-
-    #endregion
-  }
-}
Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/TestUtils.cs
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/TestUtils.cs	(revision 8887)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab.Encodings.ScheduleEncoding-3.3/TestUtils.cs	(revision 8888)
@@ -2,8 +2,10 @@
 using HeuristicLab.Encodings.IntegerVectorEncoding;
 using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Encodings.ScheduleEncoding;
 using HeuristicLab.Encodings.ScheduleEncoding.JobSequenceMatrix;
 using HeuristicLab.Encodings.ScheduleEncoding.PermutationWithRepetition;
+using HeuristicLab.Tests;
 
-namespace HeuristicLab.Encodings.ScheduleEncoding.Tests_33.Tests {
+namespace HeuristicLab.Encodings.ScheduleEncoding_33.Tests {
   public class TestUtils {
     public static JSMEncoding CreateTestJSM1() {
Index: /trunk/sources/HeuristicLab.Tests/HeuristicLab.Tests.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 8887)
+++ /trunk/sources/HeuristicLab.Tests/HeuristicLab.Tests.csproj	(revision 8888)
@@ -368,5 +368,4 @@
     <Compile Include="HeuristicLab.Encodings.ScheduleEncoding-3.3\PWRGOXCrossoverTest.cs" />
     <Compile Include="HeuristicLab.Encodings.ScheduleEncoding-3.3\PWRPPXCrossoverTest.cs" />
-    <Compile Include="HeuristicLab.Encodings.ScheduleEncoding-3.3\TestRandom.cs" />
     <Compile Include="HeuristicLab.Encodings.ScheduleEncoding-3.3\TestUtils.cs" />
     <Compile Include="HeuristicLab.Encodings.SymbolicExpressionTreeEncoding-3.4\AllArchitectureAlteringOperatorsTest.cs" />