Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/IUCIDataDescriptor.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/IUCIDataDescriptor.cs	(revision 8889)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/IUCIDataDescriptor.cs	(revision 8889)
@@ -0,0 +1,27 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.Problems.Instances.DataAnalysis {
+  public interface IUCIDataDescriptor : IDataDescriptor {
+    string Donor { get; }
+    int Year { get; }
+  }
+}
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Iris.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Iris.cs	(revision 8888)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Iris.cs	(revision 8889)
@@ -23,5 +23,5 @@
 using System;
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Iris : IDataDescriptor {
+  public class Iris : IUCIDataDescriptor {
     public string Name { get { return "Iris"; } }
     public string Description {
@@ -38,4 +38,6 @@
       }
     }
+    public string Donor { get { return "M. Marshall"; } }
+    public int Year { get { return 1988; } }
   }
 }
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Mammography.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Mammography.cs	(revision 8888)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Mammography.cs	(revision 8889)
@@ -23,6 +23,6 @@
 using System;
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Mammography : IDataDescriptor {
-    public string Name { get { return "mammography"; } }
+  public class Mammography : IUCIDataDescriptor {
+    public string Name { get { return "Mammography"; } }
     public string Description {
       get {
@@ -46,4 +46,6 @@
       }
     }
+    public string Donor { get { return "M. Elter"; } }
+    public int Year { get { return 2007; } }
   }
 }
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Thyroid.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Thyroid.cs	(revision 8888)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Thyroid.cs	(revision 8889)
@@ -23,5 +23,5 @@
 using System;
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Thyroid : IDataDescriptor {
+  public class Thyroid : IUCIDataDescriptor {
     public string Name { get { return "Thyroid"; } }
     public string Description {
@@ -39,4 +39,6 @@
       }
     }
+    public string Donor { get { return "S. Aeberhard"; } }
+    public int Year { get { return 1992; } }
   }
 }
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/UCIInstanceProvider.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/UCIInstanceProvider.cs	(revision 8888)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/UCIInstanceProvider.cs	(revision 8889)
@@ -46,5 +46,5 @@
 
     public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
-      List<IDataDescriptor> descriptorList = new List<IDataDescriptor>();
+      List<IUCIDataDescriptor> descriptorList = new List<IUCIDataDescriptor>();
       descriptorList.Add(new Iris());
       descriptorList.Add(new Mammography());
@@ -61,5 +61,6 @@
           foreach (var entry in entries.OrderBy(x => x)) {
             string prettyName = Path.GetFileNameWithoutExtension(entry);
-            IDataDescriptor desc = descriptorList.Where(x => x.Name.Equals(prettyName)).FirstOrDefault();
+            IUCIDataDescriptor desc = descriptorList.Where(x => x.Name.Equals(prettyName)).FirstOrDefault();
+            prettyName = String.Format("{0}, {1}, {2}", prettyName, desc.Donor, desc.Year);
             if (desc != null) {
               yield return new ResourceClassificationDataDescriptor(prettyName, desc.Description, entry);
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Wine.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Wine.cs	(revision 8888)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Classification/UCI/Wine.cs	(revision 8889)
@@ -23,5 +23,5 @@
 using System;
 namespace HeuristicLab.Problems.Instances.DataAnalysis {
-  public class Wine : IDataDescriptor {
+  public class Wine : IUCIDataDescriptor {
     public string Name { get { return "Wine"; } }
     public string Description {
@@ -51,4 +51,6 @@
       }
     }
+    public string Donor { get { return "S. Aeberhard"; } }
+    public int Year { get { return 1991; } }
   }
 }
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 8888)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/HeuristicLab.Problems.Instances.DataAnalysis-3.3.csproj	(revision 8889)
@@ -121,4 +121,5 @@
     <Compile Include="Classification\ResourceClassificationInstanceProvider.cs" />
     <Compile Include="Classification\UCI\Iris.cs" />
+    <Compile Include="Classification\UCI\IUCIDataDescriptor.cs" />
     <Compile Include="Classification\UCI\Mammography.cs" />
     <Compile Include="Classification\UCI\Thyroid.cs" />